searchNodes=[{"doc":"LexLuthor is a Lexer in Elixir (say that 10 times fast) which uses macros to generate a reusable lexers. Good times.LexLuthor is a state based lexer, meaning that it keeps a state stack which you can push states on and pop states off the stack, which are used to filter the applicable rules for a given state. For example:iex&gt; defmodule StringLexer do ...&gt; use LexLuthor ...&gt; defrule ~r/^&#39;/, fn(_) -&gt; :STRING end ...&gt; defrule ~r/^[^&#39;]+/, :STRING, fn(e) -&gt; { :string, e } end ...&gt; defrule ~r/^&#39;/, :STRING, fn(_) -&gt; nil end ...&gt; end ...&gt; StringLexer.lex(&quot;&#39;foo&#39;&quot;) {:ok, [%LexLuthor.Token{column: 1, line: 1, name: :string, pos: 1, value: &quot;foo&quot;}]}Rules are defined by a regular expression, an optional state (as an atom) and an action in the form of an anonymous function.When passed the string 'foo', the lexer starts in the :default state, so it filters for rules in the default state (the first rule, as it doesn't specify a state), then it filters the available rules by the longest matching regular expression. In this case, since we have only one rule (which happens to match) it's automatically the longest match.Once the longest match is found, then it's action is executed and the return value matched:If the return value is a single atom then that atom is assumed to be a state and push onto the top of the state stack.If the return value is a two element tuple then the first element is expected to be an atom (the token name) and the second element a value for this token.If the return value is nil then the top state is popped off the state stack.If lexing succeeds then you will receive an :ok tuple with the second value being a list of LexLuthor.Token structs.If lexing fails then you will receive an :error tuple which a reason and position.","ref":"LexLuthor.html","title":"LexLuthor","type":"module"},{"doc":"Define a lexing rule applicable to the default state.regex a regular expression for matching against the input string.action the function to execute when this rule is applied.","ref":"LexLuthor.html#defrule/2","title":"LexLuthor.defrule/2","type":"macro"},{"doc":"Define a lexing rule for a specific state.regex a regular expression for matching against the input string.state the lexer state in which this rule applies.action the function to execute when this rule is applied.","ref":"LexLuthor.html#defrule/3","title":"LexLuthor.defrule/3","type":"macro"},{"doc":"This module runs a Lexer module against an input string.You don't use it directly as YourModule.lex/1 is defined on your module when you use LexLuthor.","ref":"LexLuthor.Runner.html","title":"LexLuthor.Runner","type":"module"},{"doc":"Process a string against a given Lexer module and rules.module the module in which the lexer is defined.rules an array of rules to apply to the input string.string the input string to be lexed.","ref":"LexLuthor.Runner.html#lex/3","title":"LexLuthor.Runner.lex/3","type":"function"},{"doc":"Defines an individual token in the lexer output, along with handy stuff like the line and column numbers.","ref":"LexLuthor.Token.html","title":"LexLuthor.Token","type":"module"}]